мир.платформы = {
    умолчание: {
        x: 100,
        y: 100,
        ширина: 40,
        высота: 20,
        цвет: "#ff0000",
        статика: true,
    },
    задано: {},
    тела: {},
    div: {},
    transform: {},
    обновить: function() {
        for (var имя in мир.платформы.тела)
        {
            var тело = мир.платформы.тела[имя];
            if (тело.isSleeping)
            {
                continue;
            }
            var div = мир.платформы.div[имя];
            /*
            let x = тело.bounds.min.x;
            let y = тело.bounds.min.y;
            */
            let x = тело.position.x - div.offsetWidth / 2;
            let y = тело.position.y - div.offsetHeight / 2;
            let угол = тело.angle * (180 / Math.PI);
            div.style.transform = `translate(${x}px, ${y}px) rotate(${угол}deg)`;
            /*
            div.style.transform = `rotate(${угол}deg)`;
            div.style.left = `${x}px`;
            div.style.top = `${y}px`;
            */



            /*
            var задано = мир.платформы.задано[имя];
            var умолчание = мир.платформы.умолчание;
            var ширина = задано["ширина"] ? задано["ширина"] : умолчание["ширина"];
            var высота = задано["высота"] ? задано["высота"] : умолчание["высота"];
            div.style.transformOrigin = `${ширина / 2}px ${высота / 2}px`;
            */


        }
    },
};


мир.ключники.push(function(ключ, путь, значение){
    if (!ключ.startsWith("платформы"))
    {
        return;
    }

    var имя = путь[1];
    var свойство = путь[2];

    // Сохранить заданные значения.
    if (!(имя in мир.платформы.задано))
    {
        мир.платформы.задано[имя] = {};
    }
    мир.платформы.задано[имя][свойство] = значение;

console.debug("задано", мир.платформы.задано[имя]);

    // Удалить физическое тело.
    if (имя in мир.платформы.тела)
    {
        var тело = мир.платформы.тела[имя];
        Matter.Composite.remove(мир.физика.движок.world, тело);
    }
    // Пересоздать физическое тело.
    var задано = мир.платформы.задано[имя];
    var умолчание = мир.платформы.умолчание;

    var ширина = задано["ширина"] ? задано["ширина"] : умолчание["ширина"];
    var высота = задано["высота"] ? задано["высота"] : умолчание["высота"];

    var тело = Matter.Bodies.rectangle(
        задано["x"] ? задано["x"] : умолчание["x"],
        задано["y"] ? задано["y"] : умолчание["y"],
        ширина,
        высота,
        {
            isStatic: ("статика" in задано) ? задано["статика"] : умолчание["статика"],
        }
    );
console.debug("создать тело", тело);
    Matter.Composite.add(мир.физика.движок.world, тело);
    мир.платформы.тела[имя] = тело;

    // Создать div.
    if (!(имя in мир.платформы.div))
    {
        var элемент = document.createElement("div");
        элемент.style.position = "absolute";
        элемент.style.display = "block";
        элемент.style.backgroundColor = умолчание["цвет"];
        элемент.style.width = `${ширина}px`;
        элемент.style.height = `${высота}px`;
        document.body.appendChild(элемент);
        мир.платформы.div[имя] = элемент;

        //элемент.style.transformOrigin = `right bottom`;
        элемент.style.transformOrigin = `center`;
    }

    // Обновить div.
    var элемент = мир.платформы.div[имя];
    if (свойство == "ширина")
    {
        элемент.style.width = `${ширина}px`;
    }
    else if (свойство == "высота")
    {
        элемент.style.height = `${высота}px`;
    }
    else if (свойство == "цвет")
    {
        элемент.style.backgroundColor = задано["цвет"];
    }

});
